-- SpeedX = pix/s.
-- Damage = Dynamite damage value. Default = 15
-- Time Delay = Lowest time before next dynamite throwing (s).
-- Width = Range between bird and claw to apply throwing (px). Default = 64.

local function anibomb(self)
	if self.State ~= 3 then
		self.pos = 0
		self:SetImage("CUSTOM_ANGRYBIRDBOMB")
		self:SetFrame(1)
		self:SetAnimation("CUSTOM_CYCLE100")
	end
end

local function anifly(self)
	if self.State ~= 3 then
	self.pos = 1
	self:SetImage("CUSTOM_ANGRYBIRD")
	self:SetFrame(1)
	self:SetAnimation("CUSTOM_CYCLE75")
	end
end

local function movement(self)
if self.State ~= 3 then
	if self.pos == 0 then anifly(self) end
	self.pause = 0
	self.reload = self.reload + 1
	if self.XMin == self.XMax then
		self.dir = 0
	elseif self.XMin ~= self.XMax then
		if (self.X < self.XMin) then 
			self.dir = self.dir * (-1)
			self.DrawFlags.Mirror = true 
		end
		if (self.X > self.XMax) then 
			self.dir = self.dir * (-1)
			self.DrawFlags.Mirror = false 
		end
	end
	self.X = self.X + (self.step * self.dir)
	end
end

local function bomb(self)
if self.State ~= 3 then
	self.reload = 0
	self.dynamite = CreateObject {x=self.X + 48 * self.dir, y=self.Y + 16, z=self.Z, logic = "Dynamite", Damage = self.dmg}
	self.State = 0
end
end

function init(self)
	self.HitRect = {-32,-30,32,30}
	self.HitTypeFlags = ObjectType.Player
	self:SetImage("CUSTOM_ANGRYBIRD")
	self:SetFrame(1)
	self:SetAnimation("CUSTOM_CYCLE75")
	self.step = self.SpeedX / 60
	self.dir = -1
	self.reload = 0
	self.difference = 0
	self.pause = 0
	self.pos = 0
	self.countx = 1
	self.county = 1
	if self.Width == 0 then self.range = 64 else self.range = self.Width end
	if self.Damage == 0 then self.dmg = 15 else self.dmg = self.Damage end 
end

function main(self)
	self:AnimationStep()
	local claw = GetClaw()
	self.difference = self.X - claw.X
	if self.State == 0 then movement(self) end	
	if (self.difference * self.dir) <= 0 and (math.abs(self.difference) <= self.range) and (claw.Y - self.Y < 320) and (claw.Y - self.Y > 20) and (self.reload >= 180) then self.State = 1 end
	if self.State == 1 then
		if self.pos == 1 then anibomb(self) end
		self.pause = self.pause + 1
		if self.pause == 30 then
			self.State = 0
			bomb(self)
			PlaySound("CUSTOM_BIRDDROP")
		end	
	end
	if self.State == 3 then	
		birddead(self)
	end
	
end

function hit(self)
	self.dead = CreateObject {x=self.X, y=self.Y, z=1100, logic="CustomLogic", name="AngryBirdDeath"}
	if self.Powerup ~= 0 then self.powerup = CreateGoodie {x=self.X, y=self.Y, z=self.Z+1, powerup=self.Powerup} end
	self:Destroy()
end

     